' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/03/07 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmGraph

    'Zxlf[^
    Private m_bytData(360) As Byte

    Private Sub frmGraph_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'XP[O
        'picGraph.ScaleWidth = 440
        'picGraph.ScaleHeight = 326

        DrawAxis()

    End Sub

    '{^[X]𖳌ɂ
    Private Sub frmGraph_FormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing

        If e.CloseReason = CloseReason.UserClosing Then
            e.Cancel = True
        End If

    End Sub

    'tH[̃TCYύXꂽƂ̏
    Private Sub frmGraph_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        'tH[̃TCYlȉɂȂȂ悤ɂ
        If Me.Width < 300 Then Me.Width = 300
        If Me.Height < 200 Then Me.Height = 200

        'Otʏ
        'picGraph.Image.Dispose()
        picGraph.Image = Nothing

        'Ot\p̃sN`{bNXtH[̑傫ɍ킹
        'picGraph.Left = 0
        'picGraph.Top = 0
        'picGraph.Width = Me.Width - 150
        'picGraph.Height = Me.Height - 400

        'XP[O
        'picGraph.Width = 440
        'picGraph.Height = 326

        'ĕ`
        DrawAxis()
        DrawData()

    End Sub

    '̕`
    Private Sub DrawAxis()

        Dim i As Integer
        Dim Graphic As Graphics
        Dim PenColor As System.Drawing.Pen
        Dim Font As System.Drawing.Font
        Dim intWidth As Integer
        Dim intHeight As Integer

        'ĕ`悷悤ɐݒ
        If picGraph.Image Is Nothing Then
            intWidth = picGraph.ClientRectangle.Width
            intHeight = picGraph.ClientRectangle.Height
            If intWidth < 1 Then intWidth = 1
            If intHeight < 1 Then intHeight = 1
            picGraph.Image = New Bitmap(intWidth, intHeight)
        End If
        Graphic = Graphics.FromImage(picGraph.Image)
        PenColor = Pens.Black
        Font = New Font("lr SVbN", 10)

        ': px(0`360)
        ': Zx(0`255)
        'Oẗ(40,20)-(400,276)

        'x
        Graphic.DrawLine(PenColor, 30, 276, 410, 276)
        For i = 45 To 360 Step 45
            Graphic.DrawLine(PenColor, 40 + i, 271, 40 + i, 276)
            Graphic.DrawString(i.ToString(), Font, Brushes.Black, 30 + i, 280)
        Next

        Graphic.DrawString("px(x)", Font, Brushes.Black, 200, 300)

        'y
        Graphic.DrawLine(PenColor, 40, 10, 40, 296)
        Graphic.DrawLine(PenColor, 35, 21, 40, 21)
        Graphic.DrawLine(PenColor, 35, 148, 40, 148)

        Graphic.DrawString("0", Font, Brushes.Black, 30, 280)
        Graphic.DrawString("255", Font, Brushes.Black, 10, 15)
        Graphic.DrawString("Z", Font, Brushes.Black, 10, 138)
        Graphic.DrawString("x", Font, Brushes.Black, 10, 158)

    End Sub

    'Ot̃f[^̕\
    Private Sub DrawData()

        Dim i As Integer
        Dim Graphic As Graphics
        Dim PenColor As System.Drawing.Pen
        Dim intWidth As Integer
        Dim intHeight As Integer
        Dim intSx As Integer
        Dim intSy As Integer

        'ĕ`悷悤ɐݒ
        If picGraph.Image Is Nothing Then
            intWidth = picGraph.ClientRectangle.Width
            intHeight = picGraph.ClientRectangle.Height
            If intWidth < 1 Then intWidth = 1
            If intHeight < 1 Then intHeight = 1
            picGraph.Image = New Bitmap(intWidth, intHeight)
        End If
        Graphic = Graphics.FromImage(picGraph.Image)
        PenColor = Pens.Black
        intSx = 40
        intSy = 276 - m_bytData(0)
        For i = 1 To 359
            Graphic.DrawLine(PenColor, intSx, intSy, 40 + i, 276 - m_bytData(i))
            intSx = 40 + i
            intSy = 276 - m_bytData(i)
        Next

    End Sub

    'Zxl̐ݒ
    Public Sub SetData(ByVal intIndex As Integer, ByVal bytData As Byte)

        If intIndex >= 0 And intIndex < 360 Then
            m_bytData(intIndex) = bytData
        End If

    End Sub

    'ĕ`
    Public Sub Redraw()

        'picGraph.Image.Dispose()
        picGraph.Image = Nothing
        DrawAxis()
        DrawData()

    End Sub

End Class