' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/03/07 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '
    Private Const PI As Double = 3.14159265358979

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    '~
    Private m_TestCircle As New FvCircle

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        frmGraph.Show()
        'frmGraph.Activate()

        'ʂ̐
        AxFvxDisplayEx1.CreateDisplay()
        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        '~̏lݒ
        m_TestCircle.x = 337
        m_TestCircle.y = 199
        m_TestCircle.radius = 92

        AxFvxDisplayEx1.ClearOverlay()
        DrawTestCircle()
        SetGraph()

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmMain_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    '摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        SetGraph()

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

        SetGraph()

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    '~̐ݒ
    Private Sub btnSetCircle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCircle.Click

        Dim intOK As Integer

        AxFvxROI1.SetCircle(m_TestCircle)

        'FvxROIgď͈͑I_CAOo܂
        AxFvxROI1.UseCircle = True
        AxFvxROI1.UseRectangle = False
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckCircle = 1 Then
            AxFvxROI1.GetCircle(m_TestCircle)
        End If

        AxFvxDisplayEx1.ClearOverlay()
        DrawTestCircle()
        SetGraph()

    End Sub

    '~̕`
    Private Sub DrawTestCircle()

        Dim pLineSeg As New FvLineSegment

        AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
        AxFvxDisplayEx1.DrawData(0, m_TestCircle)

        'Sɏ\}[N
        pLineSeg.xs = m_TestCircle.x
        pLineSeg.xe = m_TestCircle.x
        pLineSeg.ys = m_TestCircle.y - 5
        pLineSeg.ye = m_TestCircle.y + 5
        AxFvxDisplayEx1.DrawData(0, pLineSeg)
        pLineSeg.xs = m_TestCircle.x - 5
        pLineSeg.xe = m_TestCircle.x + 5
        pLineSeg.ys = m_TestCircle.y
        pLineSeg.ye = m_TestCircle.y
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

        'S0x̐
        pLineSeg.xs = m_TestCircle.x
        pLineSeg.xe = m_TestCircle.x + m_TestCircle.radius
        pLineSeg.ys = m_TestCircle.y
        pLineSeg.ye = m_TestCircle.y
        AxFvxDisplayEx1.DrawData(0, pLineSeg)

    End Sub

    '~̔Zx擾frmGraphւ̃f[^i[
    Private Sub SetGraph()

        Dim i As Integer
        Dim intDensity As Integer
        Dim pPoint As New FvPoint

        For i = 0 To 360
            '~̍WvZ
            '㉺̍WnʂƂ͋tȂ̂ŁA]tɂĈʂɍ킹܂B
            pPoint.x = m_TestCircle.x + (m_TestCircle.radius * Math.Cos(-i * PI / 180))
            pPoint.y = m_TestCircle.y + (m_TestCircle.radius * Math.Sin(-i * PI / 180))

            'NbsO
            If pPoint.x >= 0 And pPoint.x < AxFvxImage1.ImageWidth _
                And pPoint.y >= 0 And pPoint.y < AxFvxImage1.ImageHeight Then

                'Zxl擾āAfrmGraphɊi[
                AxFvxImage1.GetPixel(pPoint, intDensity)
                frmGraph.SetData(i, Convert.ToByte(intDensity))
            Else
                '摜͂ݏoĂƂ͔Zx 0 Ƃ
                frmGraph.SetData(i, Convert.ToByte(0))
            End If
        Next

        'Ot̍XV
        frmGraph.Redraw()

    End Sub

End Class
